SystemOrganization addCategory: #'Tank Game'!

Object subclass: #TestClient3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!TestClient3 commentStamp: '<historical>' prior: 0!
A TestClient3 is a client for sending/receiving messages.
!

!TestClient3 methodsFor: 'accessing' stamp: 'CaseyPiper 7/14/2014 00:39'!
start
    | socket bytesToSend sendBuf receiveBuf done bytesSent bytesReceived packetsSent 
packetsReceived t |

   Smalltalk garbageCollect.

   Transcript show: 'starting client/server TCP test'; cr.
   Transcript show: 'initializing network ... '.
   Transcript show: 'ok'; cr.

   socket := Socket newTCP.
   socket connectTo: (NetNameResolver addressForName: 'localhost') port: 12345.
   [
      socket waitForConnectionFor: 10.
      Transcript show: 'client endpoint created'; cr.
      bytesToSend := 1000000.
      sendBuf := String new: 4000 withAll: $x.
      receiveBuf := String new: 50000.
      done := false.
      bytesSent := bytesReceived := packetsSent := packetsReceived := 0.

      t := Time millisecondsToRun:[[done] whileFalse: 
          [(socket sendDone and: [bytesSent < bytesToSend]) ifTrue: 
             [ packetsSent := packetsSent + 1.
               bytesSent := bytesSent + (socket sendData: sendBuf)].
               socket dataAvailable ifTrue: 
                  [ packetsReceived := packetsReceived + 1.
                    bytesReceived := bytesReceived + (socket receiveDataInto: receiveBuf) ].
               done := bytesSent >= bytesToSend ].
           [bytesReceived < bytesToSend] whileTrue: 
               [ socket dataAvailable ifTrue: 
                   [ packetsReceived := packetsReceived + 1.
                     bytesReceived := bytesReceived + (socket receiveDataInto: receiveBuf)]]].
       socket closeAndDestroy.
      Transcript show: 'remoteClient TCP test done; time = ' , t printString; cr.
      Transcript
          show: packetsSent printString , ' packets, ' , bytesSent printString , 
                   ' bytes sent (' , (bytesSent * 1000 // t) printString , 
                   ' bytes/sec)'; cr.
      Transcript
          show: packetsReceived printString , ' packets, ' ,
          bytesReceived printString , ' bytes received (' , 
         (bytesReceived * 1000 // t) printString , ' bytes/sec)'; cr.

  ] forkAt: Processor userBackgroundPriority.! !

Object subclass: #TestServer3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!TestServer3 commentStamp: '<historical>' prior: 0!
A TestServer3 is a simple server to receive and send data.
!

!TestServer3 methodsFor: 'accessing' stamp: 'CaseyPiper 7/14/2014 19:40'!
start
    | socket client buffer n |

   Transcript show: 'initializing network ... '.
   Transcript show: 'ok'; cr.
   socket := Socket newTCP.
   socket
       listenOn: 12345
       backlogSize: 5
       interface: (NetNameResolver addressForName: 'localhost').

    Transcript show: 'server endpoint created -- run client test in other image'; cr.

    buffer := String new: 4000.
    [
       client := socket waitForAcceptFor: 10.


       [ client isConnected] whileTrue: 
          [ client dataAvailable ifTrue: 
             [ n := client receiveDataInto: buffer.
               client sendData: buffer count: n ]].
          client closeAndDestroy.
          socket closeAndDestroy.
          Transcript cr; show: 'server endpoint destroyed'; cr.

   ] forkAt: Processor userBackgroundPriority.! !

Morph subclass: #Bullet
	instanceVariableNames: 'bulletX bulletY isAlive gravity xVel yVel timeAlive xMin xMax yMax'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!Bullet commentStamp: '<historical>' prior: 0!
A Bullet is xxxxxxxxx.

Instance Variables
	bulletX:		<Object>
	bulletY:		<Object>
	gravity:		<Object>
	isAlive:		<Object>
	timeAlive:		<Object>
	xVel:		<Object>
	yVel:		<Object>

bulletX
	- xxxxx

bulletY
	- xxxxx

gravity
	- xxxxx

isAlive
	- xxxxx

timeAlive
	- xxxxx

xVel
	- xxxxx

yVel
	- xxxxx
!

!Bullet methodsFor: 'initialize' stamp: 'GKB 7/16/2014 22:11'!
bulletX: x bulletY: y angle: ang speed:spd

	bulletX := x.
	bulletY :=y.

	xVel := spd * (ang cos).
	yVel := spd * (ang sin).
	
	isAlive := true.
	gravity := 0.005.
	timeAlive := 0.
	
	self changed.
! !

!Bullet methodsFor: 'modifying' stamp: 'GKB 7/16/2014 02:21'!
collision
	isAlive := false.
	self changed.! !

!Bullet methodsFor: 'as yet unclassified' stamp: 'GKB 7/16/2014 23:15'!
drawOn: aCanvas

	| fillRect |
	
	(isAlive) ifTrue: [  
				fillRect := (bounds origin) extent: (20@20).
				aCanvas fillOval: fillRect color: color.
				self position: (
								(bulletX + ((self width )/2))@
								(bulletY + ((self height)/2))).].! !

!Bullet methodsFor: 'modifying' stamp: 'GKB 7/16/2014 22:10'!
fire

	isAlive := true.

"	(isAlive) ifTrue: [ 
		bulletX := bulletX + (xVel*timeAlive).
		bulletY := bulletY + (yVel*timeAlive) + (0.5 * gravity* timeAlive * timeAlive).
		self position: (bulletX@bulletY).		
		timeAlive := timeAlive + (self stepTime).
]."
	self changed.! !

!Bullet methodsFor: 'modifying' stamp: 'GKB 7/16/2014 22:13'!
isAlive
	^isAlive.! !

!Bullet methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 02:17'!
step
| x y |

x := bulletX + (xVel*timeAlive).
y := bulletY + (yVel*timeAlive) + (0.5 * gravity* timeAlive * timeAlive).

	(isAlive) ifTrue:[
		((x > xMax) | (x < xMin) | (y > yMax) )
		"(timeAlive > 150)"
		ifTrue: [
				isAlive := false.
				self stopStepping.
				self delete. 
				Transcript show: 'Bullet Left Playing Field!!'.
				Transcript cr.
				  ]
		ifFalse: [ 
				bulletX := x.
				bulletY := y.
				self position: (bulletX@bulletY).
				timeAlive := timeAlive + (self stepTime).].
		]
	ifFalse: [ 
				self stopStepping.
				self delete. 
				Transcript show: 'Bullet Hit an Object'.
				Transcript cr. ].
			
	self changed.
		
"	Transcript show: xMax .
	Transcript cr."
	
	
	! !

!Bullet methodsFor: 'as yet unclassified' stamp: 'GKB 7/16/2014 01:48'!
stepTime
^ 1! !

!Bullet methodsFor: 'initialize' stamp: 'GKB 7/16/2014 22:18'!
xMin:xMn xMax:xMx yMax:yMx

	xMin := xMn.
	xMax := xMx.
	yMax := yMx.

	bulletX := 0.
	bulletY :=0.

	xVel := 0.
	yVel := 0.
	
	isAlive := false.
	gravity := 0.005.
	timeAlive := 0.
	
	self changed.
! !

Morph subclass: #GameBoard
	instanceVariableNames: 'keyBindings actionList hori vert spinR tank bullet power angle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!GameBoard commentStamp: 'GKB 7/13/2014 17:50' prior: 0!
I created this as a placeholder for the player input handler. Open the transcript to view the function flow. The temporary gameboard morph is in the top left, you can hover over that and start accpeting keyboard inputs. You can also click in the morph to hold keyboard focus when the mouse leaves. You can also call rebindKeys to rebind player functions and keys.
!

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/17/2014 00:25'!
decreasePower

	(power <= 0)
		ifTrue: [ power := 0. ]
		ifFalse: [ power := power - 1. ].
		
Transcript show: ('Decrease Power to ',(power asString)) .
Transcript cr.! !

!GameBoard methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 02:10'!
did: morph1 collideWith: morph2
"basic collision detection using rectangels"
 
	| a b c d e f g h |

	a := (morph1 position x).
	b := (morph1 position y).
	c := ((morph1 position x) + (morph1 width)).
	d := ((morph1 position y) + (morph1 height)).
	
	e := (morph2 position x).
	f := (morph2 position y).
	g := ((morph2 position x) + (morph2 width)).
	h := ((morph2 position y) + (morph2 height)).
	
	( (a < g) & (c > e) & (b < h) & (d > f))
		ifTrue: [ Transcript show: 'collision!!'. 
				 Transcript cr. 
				 ^true. ]
		ifFalse:[ ^false].
		
	! !

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/17/2014 02:07'!
fire
Transcript show: 'Fire gun'.
Transcript cr.
self startStepping. 
(bullet isAlive) 
	ifFalse: [ 
 		bullet bulletX: ((tank position x)+(tank width/2))  bulletY: ((tank position y)) angle: (-1)*(angle degreesToRadians) speed: (0.3*power/100).
		self addMorph: bullet.] 
	ifTrue: [ 
		Transcript show: 'No Ammo!!'.
		Transcript cr.]
! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/15/2014 00:46'!
handleKeystroke: anEvent
| keyValue |

keyValue := keyBindings at: (anEvent keyValue)  ifAbsent: nil.
Transcript show: 'Keyboard Input: ', (anEvent keyCharacter) asString, '. Ascii Value: ', (anEvent keyValue) asString.
Transcript cr.

keyValue = #moveLeft
	ifTrue: [self moveLeft].
keyValue = #moveRight
	ifTrue: [self moveRight].
keyValue =#rotateCW
	ifTrue: [self rotateCW].
keyValue = #rotateCCW
	ifTrue: [self rotateCCW].
keyValue =#increasePower
	ifTrue: [self increasePower].
keyValue = #decreasePower
	ifTrue: [self decreasePower].
keyValue = #fire
	ifTrue: [self fire].
keyValue = nil
	ifTrue: [Transcript show: 'No action bound to this key.'.
			Transcript cr.].! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/13/2014 17:31'!
handlesMouseDown: anEvent

	^true! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/13/2014 13:11'!
handlesMouseOver: anEvent

	^true! !

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/17/2014 00:26'!
increasePower

(power >= 100)
		ifTrue: [ power := 100. ]
		ifFalse: [ power := power + 1. ].
		
Transcript show: ('Increase Power to ',(power asString)) .
Transcript cr.! !

!GameBoard methodsFor: 'initialize' stamp: 'GKB 7/17/2014 02:07'!
initialize
	super initialize.
	
	keyBindings := Dictionary new.
		
	keyBindings at:($a asciiValue)   put: #moveLeft. 
	keyBindings at:($d asciiValue) put: #moveRight. 
	keyBindings at:($j asciiValue)   put: #rotateCCW. 
	keyBindings at:($l asciiValue)   put: #rotateCW. 
	keyBindings at:($i asciiValue)   put: #increasePower. 
	keyBindings at:($k asciiValue)   put: #decreasePower. 	
	keyBindings at:32   put: #fire. 			"32 = 	spaceBar"
	
	actionList := Set new.
					
	actionList := #(	'moveLeft' 
			   		'moveRight' 
					'rotateCW' 
					'rotateCCW' 
					'increasePower' 
					'decreasePower' 
					'fire').
	self height: 720.
	self width: 1200.
	self color: Color lightGray.
	hori := 3.
	vert := 3.
	spinR := 1.
	tank := TankMorph new.
	tank position:(100@600).
	self addMorph:  tank.
	
	"self openInWindowLabeled:'Tank Game'."
	self openInWorld.
	bullet := (Bullet new xMin: (self position x) xMax: ((self position x) + 1200) yMax: ((self position y) + 720)) .
	power := 50.
	angle := 45.! !

!GameBoard methodsFor: 'playerInput' stamp: 'JonathanMark 7/14/2014 20:28'!
mouseDown: anEvent

"game holds keyboard focus of the user clicks"
 anEvent hand newKeyboardFocus: self.



anEvent redButtonPressed
	ifTrue: [
			Transcript show: 'Red Mouse Button Click'.
			Transcript cr].
anEvent yellowButtonPressed
	ifTrue: [Transcript show: 'Yellow Mouse Button Click'.
			Transcript cr].
self changed.
! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/13/2014 15:28'!
mouseEnter: anEvent
"anEvent hand newKeyboardFocus: self"
"mouseIn := true."! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/13/2014 15:28'!
mouseLeave: anEvent
"anEvent hand newKeyboardFocus: nil"
"mouseIn := false."! !

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/17/2014 01:05'!
moveLeft
Transcript show: 'Move Tank Left'.
Transcript cr.
tank position: (tank position + (-10@0))! !

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/17/2014 01:05'!
moveRight
Transcript show: 'Move Tank Right'.
Transcript cr.
tank position: (tank position + (10@0))! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/14/2014 18:53'!
rebindKeys

	| keyToChange changeToThis |
	
	keyToChange := 0.
	changeToThis := 0.
						
	keyToChange := UIManager default 
						chooseFrom: actionList 
						lines: #(2 4 6) 
						message: 'Which action would you like to rebind?'
						title: 'Rebind keys'.
	
						
	(keyToChange = 0)
		ifFalse: [ 
				
				(keyBindings keysAndValuesDo: 
				[ :key :val | val = (actionList at: keyToChange)  
					ifTrue:[changeToThis := UIManager default 
											request: 'Bind ', (actionList at: keyToChange),' to what key? It only takes the first charater' 
											initialAnswer: key asCharacter. 
							(changeToThis isNil) ifFalse: [ keyBindings removeKey: key]. 
						    ]  
				]).

				(changeToThis isNil) 
				ifFalse: [ 
					keyBindings at: (changeToThis first asciiValue) put:(actionList at: keyToChange).
						]
				].
	! !

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/17/2014 02:24'!
rotateCCW

(angle+1 >= 360)
		ifTrue: [ angle := angle + 1 - 360. ]
		ifFalse: [ angle := angle + 1. ].
		
		tank setAngle: angle.
		self changed.
Transcript show: ('Rotate Tank Counterclockwise to ',(angle asString)) .
Transcript cr.! !

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/17/2014 02:25'!
rotateCW
(angle <= 0)
		ifTrue: [ angle := angle - 1 + 360. ]
		ifFalse: [ angle := angle - 1. ].

	tank setAngle: angle.
	self changed.
Transcript show: ('Rotate Tank Clockwise to ',(angle asString)) .
Transcript cr.! !

!GameBoard methodsFor: 'run' stamp: 'GKB 7/17/2014 02:19'!
step

	"tank position: (tank position + (hori@vert)).
	( (tank position x + tank width) > (self position x + self width) ) ifTrue:
		[ hori := (hori abs) * -1 ].
	( (tank position y + tank height) > (self position y + self height) ) ifTrue:
		[ vert  := (vert abs) * -1 ].
	( tank position x < (self position x) ) ifTrue:
		[ hori := hori abs ].
	( tank position y < (self position y) ) ifTrue:
		[ vert := vert abs ]."
	
	"tank increaseTurretAngle: 5."

	(bullet isAlive)
	ifTrue: [ 
			(self did: bullet collideWith: tank) ifTrue: [ "bullet collision." ] ].! !

!GameBoard methodsFor: 'run' stamp: 'GKB 7/17/2014 01:29'!
stepTime
^1! !

Morph subclass: #TankMorph
	instanceVariableNames: 'turretAngle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!TankMorph commentStamp: '<historical>' prior: 0!
A TankMorph is xxxxxxxxx.

Instance Variables
	turretAngle:		<Object>

turretAngle
	- xxxxx
!

!TankMorph methodsFor: 'drawing' stamp: 'GKB 7/17/2014 02:27'!
drawOn: aCanvas
	| fillRect turretStart turretEndX turretEndY |
	fillRect := (bounds origin + (20@20)) extent: (50@30).
	aCanvas fillRectangle: fillRect color: color.
	turretStart := (fillRect leftCenter + (10@0)).
	
	turretEndX := turretStart x + (20 * (turretAngle degreesToRadians cos)).
	turretEndY := turretStart y - (20 * (turretAngle degreesToRadians sin)).
	
	aCanvas line: turretStart to: (turretEndX@turretEndY) width: 3 color: Color black.! !

!TankMorph methodsFor: 'update' stamp: 'JonathanMark 7/13/2014 18:00'!
increaseTurretAngle: amount
	"comment stating purpose of message"

	turretAngle := turretAngle + (amount degreesToRadians).! !

!TankMorph methodsFor: 'initialize' stamp: 'JonathanMark 7/13/2014 18:00'!
initialize
	super initialize.
	self color: Color blue.
	self bounds: (0@0 extent: 90@70).
	
	turretAngle := 180 degreesToRadians.
	! !

!TankMorph methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 02:24'!
setAngle: angle
 turretAngle:= angle.! !
